<?php
/*
Plugin Name: APM vacatures
Plugin URI: http://www.actiefsoftware.com
Description: Plugin om APM vacatures xml feed te integereren in een wordpress site.
Version: 1.4.2
Author: Actief Software
Author URI: http://www.actiefsoftware.com
License: Free
*/
if (!defined('MYPLUGIN_THEME_DIR'))
    define('MYPLUGIN_THEME_DIR', ABSPATH . 'wp-content/themes/' . get_template());

if (!defined('MYPLUGIN_PLUGIN_NAME'))
    define('MYPLUGIN_PLUGIN_NAME', trim(dirname(plugin_basename(__FILE__)), '/'));

if (!defined('MYPLUGIN_PLUGIN_DIR'))
    define('MYPLUGIN_PLUGIN_DIR', WP_PLUGIN_DIR . '/' . MYPLUGIN_PLUGIN_NAME);

if (!defined('MYPLUGIN_PLUGIN_URL'))
    define('MYPLUGIN_PLUGIN_URL', WP_PLUGIN_URL . '/' . MYPLUGIN_PLUGIN_NAME);


  add_action('wp_head', 'apm_load_scripts', 0);
  function apm_load_scripts() {
    if (!file_exists(MYPLUGIN_PLUGIN_DIR.'/cachedir')) {mkdir(MYPLUGIN_PLUGIN_DIR.'/cachedir', 0777, true);
} }	
    
 function replace_arrays($source,$words){
    return (preg_replace_callback("/\b(\w*)\b/u", function($match) use ($words) {    if(isset($words[$match[0]])){ return ($words[$match[0]]); }else{ return($match[0]); } },  $source));
  }
  
add_shortcode('apmvacatures', 'apm_vacatures');
add_shortcode('apmvacatures_groepen', 'apm_vacatures_groepen');


function cache_xml($url) {
	
$cache_file = MYPLUGIN_PLUGIN_DIR.'/cachedir/'.urlencode($url);
if(file_exists($cache_file)) {
  if(time() - filemtime($cache_file) > 1) {
     // too old , re-fetch
     $xml = file_get_contents($url);
     file_put_contents($cache_file, $xml);
 } else {
     // cache is still fresh
	 $xml = file_get_contents($cache_file);
  }
} else {
  // no cache, create one
  $xml = file_get_contents($url);
  file_put_contents($cache_file, $xml);
}
return $xml;
}


function apm_vacatures($atts, $content = null) {

	$queryURL = parse_url( html_entity_decode( esc_url( add_query_arg( $arr_params ) ) ) );
	parse_str( $queryURL['query'], $getVar );
	$vacature_id = $getVar['vacature_id'];
	$sleutelwoord = $getVar['sleutelwoord'];
	
	$aantal_parameters=0;
	$parameters="?";
	if ($getVar['sector']<>""){$parameters.="&sector=".urlencode($getVar['sector']);$aantal_parameters++;}
	if ($getVar['regio']<>""){$parameters.="&regio=".urlencode($getVar['regio']);$aantal_parameters++;}
	if ($getVar['niveau']<>""){$parameters.="&niveau=".urlencode($getVar['niveau']);$aantal_parameters++;}
	if ($getVar['richting']<>""){$parameters.="&richting=".urlencode($getVar['richting']);$aantal_parameters++;}
	if ($getVar['kenmerk']<>""){$parameters.="&kenmerk=".urlencode($getVar['kenmerk']);$aantal_parameters++;}
	if ($getVar['dienst']<>""){$parameters.="&dienst=".urlencode($getVar['dienst']);$aantal_parameters++;}
	if ($getVar['functie']<>""){$parameters.="&functie=".urlencode($getVar['functie']);$aantal_parameters++;}
	
	
	$lokacija=get_permalink().$parameters;
	
    list($header, $regel, $footer) = explode("*****", ($content));
	

	if (isset($getVar['currentpage']) && is_numeric($getVar['currentpage'])) {
	   // cast var as int
	   $currentpage = (int) $getVar['currentpage'];
	} else {
	   // default page num
	   $currentpage = 1;
	} 	
	
     	


	if (isset($vacature_id)){$meerinfo="&actie=meerinfo&opdrachtcode=$vacature_id";}
	if (isset($sleutelwoord)){
		$zoektermen = explode(" ", $sleutelwoord);
		foreach ($zoektermen as $waarden) {
		$zoeken="&sleutelwoord=$waarden";
		}
		}
	
	if (isset($atts['per_pagina'])){$rowsperpage=$atts['per_pagina'];}else{$rowsperpage=10;}


	$url = $atts['klanturl'].$zoeken.$meerinfo;
	$xml = cache_xml($url);


	$feed = simplexml_load_string($xml);
	$numrows=$feed->TOTAAL;
	
	$count=0;
	foreach ($feed->RESULTAAT as $entry)
  	{
	  $tellen=0;	
      if ($getVar['sector']<>""){if ($getVar['sector']==$entry->SECTOR){$tellen++;} }
      if ($getVar['regio']<>""){if ($getVar['regio']==$entry->REGIO){$tellen++;} }
      if ($getVar['niveau']<>""){if ($getVar['niveau']==$entry->NIVEAU){$tellen++;} }
      if ($getVar['richting']<>""){if ($getVar['richting']==$entry->RICHTING){$tellen++;} }
      if ($getVar['kenmerk']<>""){if ($getVar['kenmerk']==$entry->KENMERK){$tellen++;} }
      if ($getVar['dienst']<>""){if ($getVar['dienst']==$entry->DIENST){$tellen++;} }
      if ($getVar['functie']<>""){if ($getVar['functie']==$entry->FUNCTIE){$tellen++;} }
 	  if ($tellen==$aantal_parameters){$count++;}

 
	  
	}


	
	$numrows=$count;
	$offset = ($currentpage - 1) * $rowsperpage;
    $totalpages = ceil($numrows / $rowsperpage);
	
	 /******  build the pagination links ******/
	// if not on page 1, don't show back links
	if ($currentpage > 1) {
	   // show << link to go back to page 1
	   $paginas.= " <a href='".$lokacija."&currentpage=1'><<</a> ";
	   // get previous page num
	   $prevpage = $currentpage - 1;
	   // show < link to go back to 1 page
	   $paginas.= " <a href='".$lokacija."&currentpage=$prevpage'><</a> ";
	} // end if
	 
	 // range of num links to show
	$range = 3;

	// loop to show links to range of pages around current page
	for ($x = ($currentpage - $range); $x < (($currentpage + $range)  + 1); $x++) {
	   // if it's a valid page number...
	   if (($x > 0) && ($x <= $totalpages)) {
		  // if we're on current page...
		  if ($x == $currentpage) {
			 // 'highlight' it but don't make a link
			 $paginas.= " [<b>$x</b>] ";
		  // if not current page...
		  } else {
			 // make it a link
			 $paginas.=" <a href='".$lokacija."".$zoeken."&currentpage=$x'>$x</a> ";
		  } // end else
	   } // end if 
	} // end for
	 
	// if not on last page, show forward and last page links        
	if ($currentpage != $totalpages) {
	   // get next page
	   $nextpage = $currentpage + 1;
		// echo forward link for next page 
	   $paginas.= " <a href='".$lokacija."".$zoeken."&currentpage=$nextpage'>></a> ";
	   // echo forward link for lastpage
	   $paginas.= " <a href='".$lokacija."".$zoeken."&currentpage=$totalpages'>>></a> ";
	} // end if
	/****** end build pagination links ******/ 

	
	
	
    $count=1;
    $rezultaat="";
	
$replacers = [
		    'TOTAAL_VELD'=>$numrows, 
		    'PAGINAS_VELD'=>"", ];	
	
	foreach ($feed->RESULTAAT as $entry)
  	{
 
	  $tellen=0;	
      if ($getVar['sector']<>""){if ($getVar['sector']==$entry->SECTOR){$tellen++;} }
      if ($getVar['regio']<>""){if ($getVar['regio']==$entry->REGIO){$tellen++;} }
      if ($getVar['niveau']<>""){if ($getVar['niveau']==$entry->NIVEAU){$tellen++;} }
      if ($getVar['richting']<>""){if ($getVar['richting']==$entry->RICHTING){$tellen++;} }
      if ($getVar['kenmerk']<>""){if ($getVar['kenmerk']==$entry->KENMERK){$tellen++;} }
      if ($getVar['dienst']<>""){if ($getVar['dienst']==$entry->DIENST){$tellen++;} }
      if ($getVar['functie']<>""){if ($getVar['functie']==$entry->FUNCTIE){$tellen++;} }
 	  if ($tellen==$aantal_parameters)
     {		 
     if (($count>=$offset) && ($count<=($offset + $rowsperpage))) 
	  {		
		
		$replacers = [
		    'TOTAAL_VELD'=>$numrows, 
		    'PAGINAS_VELD'=>$paginas, 
			'ODRACHTCODE_VELD'=> $entry->ODRACHTCODE,
			'ODRACHTCODE_ENC_VELD' => $entry->ODRACHTCODE_ENC,
			'REFERENTIE_VELD' => $entry->REFERENTIE,
			'FUNCTIE_VELD' => $entry->FUNCTIE,
			'FUNCTIE_ENC_VELD' => urlencode($entry->FUNCTIE),
			'KENMERK_VELD' => $entry->KENMERK,
			'KORTOMSCHRIJVING_VELD' => $entry->KORTOMSCHRIJVING,
			'OMSCHRIJVING_VELD' => htmlspecialchars_decode($entry->OMSCHRIJVING),
			'NIVEAU_VELD' => $entry->NIVEAU,
			'RICHTING_VELD' => $entry->RICHTING,
			'OPLEIDING_VELD' => $entry->OPLEIDING,
			'REGIO_VELD' => $entry->REGIO,
			'SECTOR_VELD' => $entry->SECTOR,
			'DIENST_VELD' => $entry->DIENST,
			'CURSUS1_VELD' => $entry->CURSUS1,
			'CURSUS2_VELD' => $entry->CURSUS2,
			'CURSUS3_VELD' => $entry->CURSUS3,
			'REGISTARTIE1_VELD' => $entry->REGISTARTIE1,
			'REGISTARTIE2_VELD' => $entry->REGISTARTIE2,
			'REGISTARTIE3_VELD' => $entry->REGISTARTIE3,
			'VAARDIGHEID1_VELD' => $entry->VAARDIGHEID1,
			'VAARDIGHEID2_VELD' => $entry->VAARDIGHEID2,
			'VAARDIGHEID3_VELD' => $entry->VAARDIGHEID3,
			'SLEUTELWOORD1_VELD' => $entry->SLEUTELWOORD1,
			'SLEUTELWOORD2_VELD' => $entry->SLEUTELWOORD2,
			'SLEUTELWOORD3_VELD' => $entry->SLEUTELWOORD3,
			'VERVOER_VELD' => $entry->VERVOER,
			'RIJBEWIJS_VELD' => $entry->RIJBEWIJS,
			'SALARIS_VELD' => $entry->SALARIS,
			'MINUREN_VELD' => $entry->MINUREN,
			'MAXUREN_VELD' => $entry->MAXUREN,
			'MAXREISAFSTAND_VELD' => $entry->MAXREISAFSTAND,
			'VANDATUM_VELD' => $entry->VANDATUM,
			'TOTDATUM_VELD' => $entry->TOTDATUM,
			'VANTIJD_VELD' => $entry->VANTIJD,
			'TOTTIJD_VELD' => $entry->TOTTIJD,
			'DATUMBINNEN_VELD' => $entry->DATUMBINNEN,
			'PLAATS_VELD' => $entry->PLAATS,
			'BEDRIJFSPROFIEL_VELD' => $entry->BEDRIJFSPROFIEL,
			'INSCHRIJVENURL_VELD' => $entry->INSCHRIJVENURL,
			'INLOGGENURL_VELD' => $entry->INLOGGENURL,
			'URL_VELD' => $entry->URL,
			'TARIEF_VELD' => $entry->TARIEF,
			'FUNCTIE2_VELD' => $entry->FUNCTIE2
		];
		

		$rezultaat.=replace_arrays($regel,$replacers);	
	   } 
	
	  $count++;	
	 }	

	}
 	


	return replace_arrays($header,$replacers).$rezultaat.replace_arrays($footer,$replacers);
}



function apm_vacatures_groepen($atts, $content = null) {

	$queryURL = parse_url( html_entity_decode( esc_url( add_query_arg( $arr_params ) ) ) );
	parse_str( $queryURL['query'], $getVar );
	$vacature_id = $getVar['vacature_id'];
	$sleutelwoord = $getVar['sleutelwoord'];
	
	if (isset($sleutelwoord)){$zoeken="&sleutelwoord=$sleutelwoord";}
	
	$aantal_parameters=0;
	$parameters="?";
	if ($getVar['sector']<>""){$parameters.="&sector=".urlencode($getVar['sector']);$aantal_parameters++;}
	if ($getVar['regio']<>""){$parameters.="&regio=".urlencode($getVar['regio']);$aantal_parameters++;}
	if ($getVar['niveau']<>""){$parameters.="&niveau=".urlencode($getVar['niveau']);$aantal_parameters++;}
	if ($getVar['richting']<>""){$parameters.="&richting=".urlencode($getVar['richting']);$aantal_parameters++;}
	if ($getVar['kenmerk']<>""){$parameters.="&kenmerk=".urlencode($getVar['kenmerk']);$aantal_parameters++;}
	if ($getVar['dienst']<>""){$parameters.="&dienst=".urlencode($getVar['dienst']);$aantal_parameters++;}
	if ($getVar['functie']<>""){$parameters.="&functie=".urlencode($getVar['functie']);$aantal_parameters++;}
	
	$lokacija=get_permalink().$parameters;
	
	$filters="";
	if ($getVar['sector']<>""){$filters.="<a href=".str_ireplace("&sector=".urlencode($getVar['sector']),"",$lokacija).">X</a> ".$getVar['sector']."<br>";}
	if ($getVar['regio']<>""){$filters.="<a href=".str_ireplace("&regio=".urlencode($getVar['regio']),"",$lokacija).">X</a> ".$getVar['regio']."<br>";}
	if ($getVar['niveau']<>""){$filters.="<a href=".str_ireplace("&niveau=".urlencode($getVar['niveau']),"",$lokacija).">X</a> ".$getVar['niveau']."<br>";}
	if ($getVar['richting']<>""){$filters.="<a href=".str_ireplace("&richting=".urlencode($getVar['richting']),"",$lokacija).">X</a> ".$getVar['richting']."<br>";}
	if ($getVar['kenmerk']<>""){$filters.="<a href=".str_ireplace("&kenmerk=".urlencode($getVar['kenmerk']),"",$lokacija).">X</a> ".$getVar['kenmerk']."<br>";}
	if ($getVar['dienst']<>""){$filters.="<a href=".str_ireplace("&dienst=".urlencode($getVar['dienst']),"",$lokacija).">X</a> ".$getVar['dienst']."<br>";}
	if ($getVar['functie']<>""){$filters.="<a href=".str_ireplace("&functie=".urlencode($getVar['functie']),"",$lokacija).">X</a> ".$getVar['functie']."<br>";}
	 
	
	if (isset($atts['pre_groep'])){$rowspergroep=$atts['pre_groep'];}else{$rowspergroep=20;}

	$url = $atts['klanturl'].$zoeken;
	$xml = cache_xml($url);


	$feed = simplexml_load_string($xml);

	
    $count=1;
    $rezultaat="";
	
	$array_sector = array();
	$array_regio = array();
	$array_niveau = array();
	$array_richting = array();
	$array_kenmerk = array();
	$array_dienst = array();
	$array_functie = array();
	
	
	foreach ($feed->RESULTAAT as $entry)
  	{
	  $tellen=0;	
      if ($getVar['sector']<>""){if ($getVar['sector']==$entry->SECTOR){$tellen++;} }
      if ($getVar['regio']<>""){if ($getVar['regio']==$entry->REGIO){$tellen++;} }
      if ($getVar['niveau']<>""){if ($getVar['niveau']==$entry->NIVEAU){$tellen++;} }
      if ($getVar['richting']<>""){if ($getVar['richting']==$entry->RICHTING){$tellen++;} }
      if ($getVar['kenmerk']<>""){if ($getVar['kenmerk']==$entry->KENMERK){$tellen++;} }
      if ($getVar['dienst']<>""){if ($getVar['dienst']==$entry->DIENST){$tellen++;} }
      if ($getVar['functie']<>""){if ($getVar['functie']==$entry->FUNCTIE){$tellen++;} }
 	  if ($tellen==$aantal_parameters)
     {		 
      if (strlen($entry->SECTOR->__toString())>0){$array_sector[] = $entry->SECTOR->__toString();}
      if (strlen($entry->REGIO->__toString())>0){$array_regio[] = $entry->REGIO->__toString();}
      if (strlen($entry->NIVEAU->__toString())>0){$array_niveau[] = $entry->NIVEAU->__toString();}
      if (strlen($entry->RICHTING->__toString())>0){$array_richting[] = $entry->RICHTING->__toString();}
      if (strlen($entry->KENMERK->__toString())>0){$array_kenmerk[] = $entry->KENMERK->__toString();}
      if (strlen($entry->DIENST->__toString())>0){$array_dienst[] = $entry->DIENST->__toString();}
      if (strlen($entry->FUNCTIE->__toString())>0){$array_functie[] = $entry->FUNCTIE->__toString();}
	 } 
	}
 	
	$count=1;
    $rezultaat_sector="";
	sort($array_sector);
	foreach (array_count_values($array_sector) as $key=>$value)
	 {
	  if ($count<=$rowspergroep)
	   {$rezultaat_sector.="<li><a href=".$lokacija."&sector=".urlencode($key).">$key</a> ($value)</li>";}
	  $count++;	
	 }
	
	$count=1;
 	$rezultaat_regio="";
	sort($array_regio);
	foreach (array_count_values($array_regio) as $key=>$value)
	 {
	  if ($count<=$rowspergroep)
	   {$rezultaat_regio.="<li><a href=".$lokacija."&regio=".urlencode($key).">$key</a> ($value)</li>";}
	  $count++;	
	 }
	 
	$count=1;
 	$rezultaat_niveau="";
	sort($array_niveau);
	foreach (array_count_values($array_niveau) as $key=>$value)
	 {
	  if ($count<=$rowspergroep)
	   {$rezultaat_niveau.="<li><a href=".$lokacija."&niveau=".urlencode($key).">$key</a> ($value)</li>";}
	  $count++;	
	 }

	$count=1;
 	$rezultaat_richting="";
	sort($array_richting);
	foreach (array_count_values($array_richting) as $key=>$value)
	 {
	  if ($count<=$rowspergroep)
	   {$rezultaat_richting.="<li><a href=".$lokacija."&richting=".urlencode($key).">$key</a> ($value)</li>";}
	  $count++;	
	 }

	$count=1;
 	$rezultaat_kenmerk="";
	sort($array_kenmerk);
	foreach (array_count_values($array_kenmerk) as $key=>$value)
	 {
	  if ($count<=$rowspergroep)
	   {$rezultaat_kenmerk.="<li><a href=".$lokacija."&kenmerk=".urlencode($key).">$key</a> ($value)</li>";}
	  $count++;	
	 }

	$count=1;
 	$rezultaat_dienst="";
	sort($array_dienst);
	foreach (array_count_values($array_dienst) as $key=>$value)
	 {
	  if ($count<=$rowspergroep)
	   {$rezultaat_dienst.="<li><a href=".$lokacija."&dienst=".urlencode($key).">$key</a> ($value)</li>";}
	  $count++;	
	 }
	 
	$count=1;
 	$rezultaat_functie="";
	sort($array_functie);
	foreach (array_count_values($array_functie) as $key=>$value)
	 {
	  if ($count<=$rowspergroep)
	   {$rezultaat_functie.="<li><a href=".$lokacija."&functie=".urlencode($key).">$key</a> ($value)</li>";}
	  $count++;	
	 }
	
	$zoekbox="<form action=".$lokacija." id=\"zoeken\" method=\"get\"><input type=\"text\" name=\"sleutelwoord\"></form>";
	$zoekknop="<input type=\"submit\" form=\"zoeken\" value=\"Zoeken\">";
	
    if ($filters<>""){$filters="Filters:<br>".$filters."<br>";}	
	 
	$replacers = [
		    'FILTERS'=>$filters, 
		    'SECTOR_GROEP'=>$rezultaat_sector, 
		    'REGIO_GROEP'=>$rezultaat_regio, 
		    'NIVEAU_GROEP'=>$rezultaat_niveau, 
		    'RICHTING_GROEP'=>$rezultaat_richting, 
		    'KENMERK_GROEP'=>$rezultaat_kenmerk, 
		    'DIENST_GROEP'=>$rezultaat_dienst, 
			'ZOEK_BOX'=>$zoekbox,
			'ZOEK_KNOP'=>$zoekknop,
			'FUNCTIE_GROEP'=>$rezultaat_functie
     ];
	  
	return replace_arrays($content,$replacers);
}



?>